#[macro_use]
mod macros;

pub mod amd;
pub mod core;
pub mod ext;
pub mod khr;

pub mod prelude;

pub trait PNextIn<T> {
    fn chain(&mut self, p_next: &T);
}

pub trait PNextOut<T> {
    fn chain(&mut self, p_next: &mut T);
}

use std::slice;

fn raw_to_slice<'a, T: Clone>(pointer: *const T, size: u32) -> &'a [T] {
    unsafe { slice::from_raw_parts(pointer, size as usize) }
}

fn raw_to_slice_mut<'a, T: Clone>(pointer: *mut T, size: u32) -> &'a mut [T] {
    unsafe { slice::from_raw_parts_mut(pointer, size as usize) }
}
